import { createAction, props } from '@ngrx/store';

import {
  AuthRequest,
  AuthResponse,
  DeptRequest,
  DeptInfo,
  DeptUserRequest,
  UserInfoSS,
  DeptUserResponse,
  SelectedDept
} from '@ucap-webmessenger/protocol-query';

/** 권한 조회 */
export const auth = createAction(
  '[Messenger::Query] Auth',
  props<AuthRequest>()
);

export const authSuccess = createAction(
  '[Messenger::Query] Auth Success',
  props<{ res: AuthResponse }>()
);

export const authFailure = createAction(
  '[Messenger::Query] Auth Failure',
  props<{ error: any }>()
);

/** 부서 조회 */
export const dept = createAction(
  '[Messenger::Query] Dept',
  props<DeptRequest>()
);

export const deptSuccess = createAction(
  '[Messenger::Query] Dept Success',
  props<{ departmentInfoList: DeptInfo[] }>()
);

export const deptFailure = createAction(
  '[Messenger::Query] Dept Failure',
  props<{ error: any }>()
);

export const selectedTree = createAction(
  '[Messenger::Query] selected Department on tree Seq',
  props<{ deptSeq: number }>()
);

/** 트리 > 부서 선택 > 부서원 조회 */
export const selectedDept = createAction(
  '[Messenger::Query] selected Department on tree',
  props<SelectedDept>()
);

export const selectedDeptSuccess = createAction(
  '[Messenger::Query] selected Department on tree Success',
  props()
);

export const deptUser = createAction(
  '[Messenger::Query] Dept User',
  props<DeptUserRequest>()
);

export const deptUserSuccess = createAction(
  '[Messenger::Query] Dept User Success',
  props<{ userInfos: UserInfoSS[] }>()
);

export const deptUserFailure = createAction(
  '[Messenger::Query] Dept User Failure',
  props<{ error: any }>()
);

export const myDeptUser = createAction(
  '[Messenger::Query] My Dept User',
  props<DeptUserRequest>()
);

export const myDeptUserSuccess = createAction(
  '[Messenger::Query] My Dept User Success',
  props<{ userInfos: UserInfoSS[] }>()
);

export const myDeptUserFailure = createAction(
  '[Messenger::Query] My Dept User Failure',
  props<{ error: any }>()
);

/** 조직도 > 조회 */
export const searchDeptUser = createAction(
  '[Messenger::Query] Search Dept User',
  props<{
    companyCode: string;
    search: string;
    pageCurrent?: number;
    userList?: UserInfoSS[];
  }>()
);

export const searchDeptUserSuccess = createAction(
  '[Messenger::Query] Search Dept User Success',
  props<{ userInfos: UserInfoSS[] }>()
);

export const searchDeptUserFailure = createAction(
  '[Messenger::Query] Search Dept User Failure',
  props<{ error: any }>()
);

export const clearSearchDeptUser = createAction(
  '[Messenger::Query] Clear Search Dept User Success',
  props()
);

/** 통합검색 > 조회 */
export const integrateSearchDeptUser = createAction(
  '[Messenger::Query] Integration Search Dept User',
  props<{
    companyCode: string;
    search: string;
    pageCurrent?: number;
    userList?: UserInfoSS[];
  }>()
);

export const integrateSearchDeptUserSuccess = createAction(
  '[Messenger::Query] Integration Search Dept User Success.',
  props<{ userInfos: UserInfoSS[] }>()
);

export const integrateSearchDeptUserFailure = createAction(
  '[Messenger::Query] Integration Search Dept User Failure.',
  props<{ error: any }>()
);

export const integrateClearSearchDeptUser = createAction(
  '[Messenger::Query] Integration Clear Search Dept User Success',
  props()
);
