import { Selector, createSelector } from '@ngrx/store';
import {
  AuthResponse,
  DeptInfo,
  UserInfoSS,
  SelectedDept
} from '@ucap-webmessenger/protocol-query';

export interface State {
  auth?: AuthResponse;

  departmentInfoList: DeptInfo[] | null;

  isSearch: boolean;
  selectedDepartmentProcessing: boolean;
  selectedDepartment: SelectedDept | null;
  selectedTree: number | null;

  searchDepartmentUserInfoList: UserInfoSS[] | null;
  departmentUserInfoList: UserInfoSS[] | null;
  myDepartmentUserInfoList: UserInfoSS[] | null;

  integrateSearchDepartmentProcessing: boolean;
  integrateSearchDepartmentUserInfoList: UserInfoSS[] | null;
}

export const initialState: State = {
  auth: null,
  departmentInfoList: null,

  isSearch: false,
  selectedDepartmentProcessing: false,
  selectedDepartment: null,
  selectedTree: null,

  searchDepartmentUserInfoList: null,
  departmentUserInfoList: null,
  myDepartmentUserInfoList: null,

  integrateSearchDepartmentProcessing: false,
  integrateSearchDepartmentUserInfoList: null
};

export function selectors<S>(selector: Selector<any, State>) {
  return {
    auth: createSelector(selector, (state: State) => state.auth),
    departmentInfoList: createSelector(
      selector,
      (state: State) => state.departmentInfoList
    ),

    isSearch: createSelector(selector, (state: State) => state.isSearch),
    selectedDepartmentProcessing: createSelector(
      selector,
      (state: State) => state.selectedDepartmentProcessing
    ),
    selectedDepartment: createSelector(
      selector,
      (state: State) => state.selectedDepartment
    ),
    selectedTree: createSelector(
      selector,
      (state: State) => state.selectedTree
    ),

    searchDepartmentUserInfoList: createSelector(
      selector,
      (state: State) => state.searchDepartmentUserInfoList
    ),
    departmentUserInfoList: createSelector(
      selector,
      (state: State) => state.departmentUserInfoList
    ),
    myDepartmentUserInfoList: createSelector(
      selector,
      (state: State) => state.myDepartmentUserInfoList
    ),

    integrateSearchDepartmentProcessing: createSelector(
      selector,
      (state: State) => state.integrateSearchDepartmentProcessing
    ),
    integrateSearchDepartmentUserInfoList: createSelector(
      selector,
      (state: State) => state.integrateSearchDepartmentUserInfoList
    )
  };
}
